package com.s434666;

import com.s434666.models.Person;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

public class Main {
    private static PeselValidator peselValidator;

    public static void main(String[] args) {
        peselValidator = new PeselValidator();

        var people = readPeople();
        if(saveToFile(people))
            System.out.println("Pomyślnie zapisano liste do pliku");
        else
            System.out.println("Nie udało się zapisać listy do pliku");
    }

    private static Iterable<Person> readPeople(){
        var people = new TreeMap<String, Person>();
        var scanner = new Scanner(System.in);

        while (true){
            System.out.println("Miasto: ");
            var city = scanner.nextLine();
            System.out.println("Imię: ");
            var name = scanner.nextLine();
            System.out.println("Nazwisko: ");
            var surname = scanner.nextLine();
            System.out.println("PESEL: ");

            var pesel = scanner.nextLine();
            if(peselValidator.validatePesel(pesel))
                people.put(pesel, new Person(city, name,surname, pesel));
            else
                System.out.println("Niepoprawny PESEL! Ta osoba nie zostanie dodana do bazy!");

            System.out.println("Czy chcesz dodać koleją osobę? y - tak");
            if(scanner.nextLine().trim().toUpperCase().charAt(0) != 'Y')
                break;
        }

        return people.values();
    }

    private static Boolean saveToFile(Iterable<Person> people){
        var file = new File("lista.txt");
        try {
            file.createNewFile();
            FileOutputStream fileOutputStream = new FileOutputStream(file);
            BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(fileOutputStream));

            for (Person person : people) {
                bufferedWriter.write(person.print());
                bufferedWriter.newLine();
            }
            bufferedWriter.close();
        } catch (Exception ex){
            return false;
        }
        return true;
    }
}
