package com.s434666;

import java.util.stream.IntStream;

public class PeselValidator {
    public Boolean validatePesel(String pesel){
        if(pesel.length()!=11)
            return false;

        try{
            var splitedNumbers = pesel.chars().map(c-> Character.getNumericValue(c)).toArray();
            var factors  = new int[]{9,7,3,1,9,7,3,1,9,7};

            //DLACZEGO W JAVIE NIE MA ZIP WITH?! :((((
            var controlSum = IntStream.range(0,10).map(i->factors[i]*splitedNumbers[i]).sum();

            return controlSum%10 == splitedNumbers[10];
        }
        catch(Exception ex){
            return false;
        }
    }
}
